#ifndef _DSTRING_H_
#define _DSTRING_H_

class DSTRING
{
public:
	DSTRING();
	DSTRING(const DSTRING &str);
	DSTRING(int size);
	DSTRING(const char *str);
	~DSTRING();

	int Length(void) const;
	bool Resize(int size);
	DSTRING Substr(int start, int end) const;

	char &operator [] (int index);
	char operator [] (int index) const;

	operator int() const;
	operator char *();
	operator const char *() const;

	const DSTRING &operator = (const DSTRING &rhs);
	const DSTRING &operator = (const char *rhs);
	const DSTRING &operator = (int rhs);

	const DSTRING &operator += (const DSTRING &rhs);
	const DSTRING &operator += (const char *rhs);
	const DSTRING &operator += (char rhs);
	const DSTRING &operator += (int rhs);

private:
	int Size;
	char *String;
};

DSTRING operator + (const DSTRING &lhs, const DSTRING &rhs);
DSTRING operator + (const DSTRING &lhs, const char *rhs);
DSTRING operator + (const char *lhs, const DSTRING &rhs);
DSTRING operator + (const DSTRING &lhs, char rhs);
DSTRING operator + (char lhs, const DSTRING &rhs);

bool operator == (const DSTRING &lhs, const DSTRING &rhs);
bool operator != (const DSTRING &lhs, const DSTRING &rhs);

bool operator == (const DSTRING &lhs, const char *rhs);
bool operator == (const char *lhs, const DSTRING &rhs);
bool operator != (const DSTRING &lhs, const char *rhs);
bool operator != (const char *lhs, const DSTRING &rhs);

#endif