#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <windows.h>
#include <zlib.h>
#include "modlist.h"

MODLIST::MODLIST()
{
	cMod = NULL;
}

bool MODLIST::Save(gzFile zf)
{
    gzputdw(zf, ModInfo.Length());
	ModInfo.GotoStart();
	if(ModInfo.Length() > 0)
	{
		do{
			ModInfo.GetItem().Save(zf);
		}while(ModInfo.NextItem());
	}
	return true;
}

bool MODLIST::Load(gzFile zf)
{
	int c, n = gzgetdw(zf);
	ModInfo.DeleteAll();
	for(c = 0; c < n; c++)
		ModInfo.NewItem().Load(zf);
	return true;
}

bool MODLIST::SelectMod(const char *name)
{
	if(ModInfo.Length() <= 0)
		return false;

	ModInfo.GotoStart();
	do{
		if(stricmp(ModInfo.GetItem().Name, name) == 0)
		{
			cMod = &ModInfo.GetItem();
			return true;
		}
	}while(ModInfo.NextItem());

	return false;
}

bool MODLIST::RemoveMod(void)
{
	if(!cMod || ModInfo.Length() < 1)
		return false;

	ModInfo.GotoStart();
	do{
		if(cMod == &ModInfo.GetItem())
		{
			ModInfo.SetInsertMode(LLIST_POS);
			ModInfo.DeleteItem();
			ModInfo.SetInsertMode(LLIST_END);
			cMod = NULL;
			return true;
		}
	}while(ModInfo.NextItem());

	return false;
}

bool MODLIST::FileShared(const char *fname)
{
	int c;
	if(!cMod || ModInfo.Length() < 1)
		return true;
	if(ModInfo.Length() == 1)
		return false;

	ModInfo.GotoStart();
	do{
		if(cMod != &ModInfo.GetItem())
		{
			for(c = 0; c < ModInfo.GetItem().nFiles; c++)
			{
				if(stricmp(ModInfo.GetItem().FileInfo[c].Name, fname) == 0)
					return true;
			}
		}
	}while(ModInfo.NextItem());

	return false;
}
