#ifndef _MODLIST_H_
#define _MODLIST_H_

#include <stdio.h>
#include "dstring.h"
#include "lnklist.h"
#include "mod.h"

#define EXT_NIF                   1
#define EXT_BMP                   2
#define EXT_TGA                   3
#define EXT_DDS                   4
#define EXT_ESP                   5
#define EXT_ESM                   6
#define EXT_WAV                   7
#define EXT_MP3                   8
#define EXT_KF                    9 // added some additional file types to recognize in the zip file's we install...
#define EXT_FNT                   10 // added some additional file types to recognize in the zip file's we install...
#define EXT_TEX                   11 // added some additional file types to recognize in the zip file's we install...
#define EXT_DB                    12 // added some additional file types to recognize in the zip file's we install...
#define EXT_IFL                   13 // added some additional file types to recognize in the zip file's we install...


class MODLIST
{
public:
	MODLIST();

	bool Save(gzFile zf);
	bool Load(gzFile zf);

	bool SelectMod(const char *name);
	bool RemoveMod(void);
	bool FileShared(const char *fname);

	MOD *cMod;
	LLIST<MOD> ModInfo;
};

bool shorten_path(char *path);
void check_path_sep(char *path);
int check_extension(const char *fname);
int find_file2(char *fname);
int file_exists2(char *fname);
int file_exists3(char *fname);
int file_exists(const char *fname);
void extract_path(const char *data, char *buf);
void check_path(char *path);
int compare_file_date(const char *fname, FILETIME *ft);
MOD *scan_esm(const char *fname);
MOD *scan_esp(const char *fname);
bool install_mod(const char *fname);
bool archive_mod(const char *fname, MOD *mod);
void clean_datafiles(int scan_sound);
void gzputdw(gzFile file, int d);
int gzgetdw(gzFile file);
void create_dir(const char *path);
void remove_dir(const char *path);

#endif
